Qore::FileOutputStream Class Reference

This class implements the OutputStream interface for writing bytes to a file. More...

Inheritance diagram for Qore::FileOutputStream:
[legend]

## Public Member Functions

nothing | close ()
| Closes the output stream and releases any resources. More...
| constructor (string fileName, bool append=False, softint mode=0644, *string encoding)
| Creates the FileOutputStream by opening or creating a file. More...
string | getEncoding ()
| Returns the character encoding for the FileOutputStream. More...
nothing | write (binary data)
| Writes bytes to the output stream. More...
Public Member Functions inherited from Qore::OutputStream
| constructor ()
| Constructor. More...

## Detailed Description

This class implements the OutputStream interface for writing bytes to a file.

Restrictions:
  Qore::PO_NO_FILESYSTEM

Example: FileOutputStream basic usage
  FileOutputStream fos("file.ext");
  fos.write(<01>);
  fos.write(<0203>);
  fos.close();
  # file.ext now contains three bytes: 01 02 03

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown.

See also
  StreamWriter for a class that can be used to write various kinds of data to an OutputStream

Since
  Qore 0.8.13

## Member Function Documentation

## close()

nothing Qore::FileOutputStream::close | ( |  | ) |

virtual

Closes the output stream and releases any resources.

Any methods called on a closed output stream will throw an IO-ERROR exception.

Exceptions

  IO-ERROR | if an I/O error occurs
  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::OutputStream.

## constructor()

Qore::FileOutputStream::constructor | ( | string | fileName,
|  | bool | append = `False`,
|  | softint | mode = `0644`,
|  | *string | encoding
| ) |  |

Creates the FileOutputStream by opening or creating a file.

Parameters

  fileName | the name of the file to open
  append | if true, then bytes will be written to the end of the file
  mode | permission bits for when the file is to be created (default: 0644)
  encoding | the character encoding of the file; if not present, defaults to the default encoding

Note
  raw binary data is written to the output stream, so it's up to the caller to ensure that only valid character data for the given encoding is written to the FileOutputStream object

## getEncoding()

string Qore::FileOutputStream::getEncoding | ( |  | ) |

Returns the character encoding for the FileOutputStream.

Code Flags:
  CONSTANT

Example:
  FileOutputStream fos(filname);
  string encoding = fos.getEncoding();

Returns
  the character encoding for the FileOutputStream

Note
  raw binary data is written to the output stream, so it's up to the caller to ensure that only valid character data for the given encoding is written to the FileOutputStream object

## write()

nothing Qore::FileOutputStream::write | ( | binary | data | ) |

virtual

Writes bytes to the output stream.

Parameters

  data | the data to write

Example:
  FileOutputStream fos("file.ext");
  fos.write(<01>);
  fos.write(<0203>);
  fos.close();
  # file.ext now contains three bytes: 01 02 03

Exceptions

  FILE-WRITE-ERROR | if an I/O error occurs
  OUTPUT-STREAM-CLOSED-ERROR | the output stream has already been closed
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Note
  raw binary data is written to the output stream, so it's up to the caller to ensure that only valid character data for the given encoding is written to the FileOutputStream object

Implements Qore::OutputStream.